#region Copyright Syncfusion Inc. 2001 - 2007
//
//  Copyright Syncfusion Inc. 2001 - 2007. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Drawing;
using Syncfusion.Windows.Forms.Chart;
using Syncfusion.Windows.Forms.Chart.Scrolling;

namespace StripLine_ChartSample
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Chart.ChartControl chartControl1;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.RadioButton radioButton1;
        private System.Windows.Forms.RadioButton radioButton2;
		private ChartStripLine optimalZoneX=new ChartStripLine(); 
		private ChartStripLine optimalZoneY=new ChartStripLine(); 
		private double ymax=0;
		private double xmax=0;
        private Label label11;
        private Label label9;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
        IChartScrollBar primaryScroll = null;
		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			
			InitializeComponent();
            this.chartControl1.LayoutCompleted += new EventHandler(chartControl1_LayoutCompleted);
            primaryScroll = this.chartControl1.GetVScrollBar(this.chartControl1.PrimaryYAxis);
            primaryScroll.ScrollBar.VisibleChanged += new EventHandler(ScrollBar_VisibleChanged);
           
            this.chartControl1.EnableXZooming = true;
            this.chartControl1.EnableYZooming = true;
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

        void ScrollBar_VisibleChanged(object sender, EventArgs e)
        {
            primaryScroll = this.chartControl1.GetVScrollBar(this.chartControl1.PrimaryYAxis);
            primaryScroll.Visible = false;
        }

        void chartControl1_LayoutCompleted(object sender, EventArgs e)
        {
            PositionAllYAxes();
        }
        ChartAxis a;
        private void PositionAllYAxes()
        {
            for (int i = 0; i < chartControl1.Axes.Count; i++)
            {
                
                 a = chartControl1.Axes[i];
                
                if (a != chartControl1.PrimaryYAxis && a.Orientation == ChartOrientation.Vertical)
                {
                    a.LocationType = ChartAxisLocationType.Set;
                    a.Location = new PointF(chartControl1.PrimaryYAxis.Location.X, chartControl1.PrimaryYAxis.Location.Y);
                }
            }
            HideOtherAxes(a);
            this.chartControl1.Redraw(true);
        }
        private void HideOtherAxes(ChartAxis currentAxis)
        {
            int axesCount = this.chartControl1.Axes.Count;
            for (int i = 0; i < axesCount; i++)
            {
                ChartAxis a = this.chartControl1.Axes[i];
                if (a != currentAxis && a.Orientation == ChartOrientation.Vertical)
                {
                    a.DrawGrid = false;
                    a.TickLabelsDrawingMode = ChartAxisTickLabelDrawingMode.None;
                }
            }

            currentAxis.DrawGrid = true;
            currentAxis.TickLabelsDrawingMode = ChartAxisTickLabelDrawingMode.AutomaticMode;
            currentAxis.Location = new PointF(this.chartControl1.PrimaryYAxis.Location.X, this.chartControl1.PrimaryYAxis.Location.Y);

            currentAxis.ZoomFactor = this.chartControl1.PrimaryYAxis.ZoomFactor;
        }

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(Form1));
            this.chartControl1 = new Syncfusion.Windows.Forms.Chart.ChartControl();
            this.panel1 = new System.Windows.Forms.Panel();
            this.radioButton1 = new System.Windows.Forms.RadioButton();
            this.radioButton2 = new System.Windows.Forms.RadioButton();
            this.label11 = new System.Windows.Forms.Label();
            this.label9 = new System.Windows.Forms.Label();
            this.panel1.SuspendLayout();
            this.SuspendLayout();
            // 
            // chartControl1
            // 
            this.chartControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
                        | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            // 
            // 
            // 
            this.chartControl1.ChartArea.TextRenderingHint = System.Drawing.Text.TextRenderingHint.SystemDefault;
            //this.chartControl1.ChartArea.XAxesLayoutMode = Syncfusion.Windows.Forms.Chart.ChartAxesLayoutMode.Stacking;
            //this.chartControl1.ChartArea.YAxesLayoutMode = Syncfusion.Windows.Forms.Chart.ChartAxesLayoutMode.Stacking;
            this.chartControl1.ChartAreaMargins = new Syncfusion.Windows.Forms.Chart.ChartMargins(10, 10, 20, 10);
            this.chartControl1.ChartInterior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.Vertical, System.Drawing.Color.FromArgb(((int)(((byte)(203)))), ((int)(((byte)(209)))), ((int)(((byte)(226))))), System.Drawing.Color.FromArgb(((int)(((byte)(227)))), ((int)(((byte)(232)))), ((int)(((byte)(243))))));
            this.chartControl1.Font = new System.Drawing.Font("Arial", 12F);
            // 
            // 
            // 
            this.chartControl1.Legend.BackColor = System.Drawing.SystemColors.Control;
            this.chartControl1.Legend.Font = new System.Drawing.Font("Verdana", 10F);
          //  this.chartControl1.Legend.IsWindowLess = false;
            this.chartControl1.Legend.Location = new System.Drawing.Point(373, 208);
            this.chartControl1.Legend.TabIndex = 3;
            this.chartControl1.Legends.Add(this.chartControl1.Legend);
            this.chartControl1.Location = new System.Drawing.Point(0, 0);
            this.chartControl1.Name = "chartControl1";
            this.chartControl1.PrimaryXAxis.ScrollBar = null;
            this.chartControl1.PrimaryYAxis.ScrollBar = null;
            this.chartControl1.Size = new System.Drawing.Size(472, 408);
            this.chartControl1.TabIndex = 0;
            this.chartControl1.Text = "EssentialChart";
            // 
            // 
            // 
            this.chartControl1.Title.Name = "Def_title";
            this.chartControl1.Title.Size = new System.Drawing.Size(120, 27);
            this.chartControl1.Title.TabIndex = 2;
            this.chartControl1.Title.Text = "EssentialChart";
            this.chartControl1.Titles.Add(this.chartControl1.Title);
             
            // panel1
            // 
            this.panel1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.panel1.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(214)))), ((int)(((byte)(231)))), ((int)(((byte)(247)))));
            this.panel1.Controls.Add(this.radioButton1);
            this.panel1.Controls.Add(this.radioButton2);
            this.panel1.Controls.Add(this.label11);
            this.panel1.Controls.Add(this.label9);
            this.panel1.Location = new System.Drawing.Point(472, 0);
            this.panel1.Name = "panel1";
            this.panel1.Size = new System.Drawing.Size(104, 408);
            this.panel1.TabIndex = 1;
            // 
            // radioButton1
            // 
            this.radioButton1.Checked = true;
            this.radioButton1.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.radioButton1.Location = new System.Drawing.Point(11, 169);
            this.radioButton1.Name = "radioButton1";
            this.radioButton1.Size = new System.Drawing.Size(56, 24);
            this.radioButton1.TabIndex = 0;
            this.radioButton1.TabStop = true;
            this.radioButton1.Text = "XAxis";
            this.radioButton1.CheckedChanged += new System.EventHandler(this.radioButton1_CheckedChanged);
            // 
            // radioButton2
            // 
            this.radioButton2.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.radioButton2.Location = new System.Drawing.Point(11, 201);
            this.radioButton2.Name = "radioButton2";
            this.radioButton2.Size = new System.Drawing.Size(56, 24);
            this.radioButton2.TabIndex = 1;
            this.radioButton2.Text = "YAxis";
            this.radioButton2.CheckedChanged += new System.EventHandler(this.radioButton1_CheckedChanged);
            // 
            // label11
            // 
            this.label11.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(123)))), ((int)(((byte)(166)))), ((int)(((byte)(231)))));
            this.label11.Location = new System.Drawing.Point(8, 152);
            this.label11.Name = "label11";
            this.label11.Size = new System.Drawing.Size(90, 1);
            this.label11.TabIndex = 4;
            // 
            // label9
            // 
            this.label9.AutoSize = true;
            this.label9.BackColor = System.Drawing.Color.Transparent;
            this.label9.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label9.Location = new System.Drawing.Point(5, 136);
            this.label9.Name = "label9";
            this.label9.Size = new System.Drawing.Size(60, 14);
            this.label9.TabIndex = 3;
            this.label9.Text = "Strip Line";
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(576, 406);
            this.Controls.Add(this.panel1);
            this.Controls.Add(this.chartControl1);
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.Name = "Form1";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "EssentialChart - StipLine Chart";
            this.Load += new System.EventHandler(this.Form1_Load);
            this.panel1.ResumeLayout(false);
            this.panel1.PerformLayout();
            this.ResumeLayout(false);

		}
		#endregion

		private void InitializeControlSettings()
		{
			this.chartControl1.Font = new System.Drawing.Font("Arial", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));

			// Specify a ChartPalette:
			
			Color[] color1=new Color[]{Color.FromArgb(255,110,2),Color.FromArgb(252,175,85),Color.FromArgb(255,110,2)};
            this.chartControl1.Palette = ChartColorPalette.Custom;
            this.chartControl1.Model.ColorModel.CustomColors = color1;			
						
			//this.chartControl1.ChartArea.PrimaryXAxis.HidePartialLabels = true;
            this.chartControl1.ChartInterior = new Syncfusion.Drawing.BrushInfo(Color.Transparent);
            this.chartControl1.BackInterior = new Syncfusion.Drawing.BrushInfo(Color.White);
            this.chartControl1.ChartArea.BackInterior = new Syncfusion.Drawing.BrushInfo(Color.White);

            this.chartControl1.PrimaryXAxis.GridLineType.ForeColor = Color.DarkGray;
            this.chartControl1.PrimaryYAxis.GridLineType.ForeColor = Color.DarkGray;

            this.chartControl1.PrimaryXAxis.LineType.ForeColor = Color.DarkGray;
            this.chartControl1.PrimaryYAxis.LineType.ForeColor = Color.DarkGray;

            this.chartControl1.TextRenderingHint = System.Drawing.Text.TextRenderingHint.ClearTypeGridFit;

            this.chartControl1.Legend.BackColor = Color.White;
            this.chartControl1.Legend.Border.ForeColor = Color.DarkGray;
		}

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			InitializeChartData();
			CreateXStripLine();
			CreateYStripLine();
			InitializeControlSettings();
            
			  
             
		}

		protected void InitializeChartData()
		{
			this.chartControl1.LegendPosition = ChartDock.Top;
			
			ChartSeries series = this.chartControl1.Model.NewSeries("Engine");
				
			series.Points.Add(10, 200);
			series.Points.Add(20, 234);
			series.Points.Add(28, 100);
			series.Points.Add(40, 340);
			series.Points.Add(55, 430);
			series.Points.Add(16, 450);
			series.Points.Add(37, 567);
			series.Points.Add(48, 230);
			series.Points.Add(29, 120);
			series.Points.Add(10, 370);

            series.Type = ChartSeriesType.Line;
			series.Text = series.Name;
			this.chartControl1.Series.Add(series);

            ChartAxis axis = new ChartAxis();
            axis.Orientation = ChartOrientation.Vertical;
            axis.OpposedPosition = false;
            axis.DrawGrid = false;
            axis.TickSize = new Size(6, 1);
            axis.SmallTicksPerInterval = 5;
            axis.SmallTickSize = new Size(3, 1);
            axis.TickColor = Color.Red;
            axis.ForeColor = Color.Red;
            axis.LineType.ForeColor = Color.Red;
            axis.TitleAlignment = StringAlignment.Center;
            axis.LocationType = ChartAxisLocationType.Auto;
            axis.AutoSize = true;
            axis.RangeType = ChartAxisRangeType.Set;
            axis.Range = new MinMaxInfo(0, 800, 100);
            this.chartControl1.Axes.Add(axis);
            series.YAxis = axis;
            
            chartControl1.ChartArea.XAxesLayoutMode = ChartAxesLayoutMode.Stacking;
            chartControl1.ChartArea.YAxesLayoutMode = ChartAxesLayoutMode.Stacking;

            ymax = this.chartControl1.Series[0].Points[0].YValues[0];
            xmax = this.chartControl1.Series[0].Points[0].X;
            for (int i = 0; i < this.chartControl1.Series[0].Points.Count; i++)
            {

                if (ymax < this.chartControl1.Series[0].Points[i].YValues[0])
                {
                    ymax = this.chartControl1.Series[0].Points[i].YValues[0];
                    xmax = this.chartControl1.Series[0].Points[i].X;

                }
            }
			//Chart Appearance
			this.chartControl1.PrimaryXAxis.Title="Speed(rpm)";
			this.chartControl1.PrimaryYAxis.Title="Temperature";
			this.chartControl1.Text="Speed-Torque Characteristics";

            this.chartControl1.PrimaryXAxis.RangeType = ChartAxisRangeType.Set;
            this.chartControl1.PrimaryXAxis.Range = new MinMaxInfo(0, 60, 10);
           


		}
		private void CreateXStripLine()
		{
			optimalZoneX.Enabled = this.radioButton1.Checked;
			optimalZoneX.StartAtAxisPosition = false;
			optimalZoneX.Vertical = true;
			optimalZoneX.Start = xmax;
			optimalZoneX.Width = 2;
			optimalZoneX.End = xmax+this.optimalZoneX.Width;
			optimalZoneX.Text = "Speed at Max.Torque:"+xmax;
			optimalZoneX.TextColor=Color.Red;
			optimalZoneX.TextAlignment=ContentAlignment.MiddleCenter;
			optimalZoneX.Font =  new Font(optimalZoneX.Font.FontFamily.Name,12);
			optimalZoneX.Interior = new BrushInfo(230, new BrushInfo(GradientStyle.Vertical,Color.FromArgb(41,65,125) , Color.FromArgb(41,65,125)));
			this.chartControl1.PrimaryXAxis.StripLines.Add(optimalZoneX);
		}

		private void CreateYStripLine()
		{
			optimalZoneY.Enabled = this.radioButton2.Checked ;		   
			optimalZoneY.Vertical = false;
			optimalZoneY.StartAtAxisPosition = false;
			optimalZoneY.Start = ymax;
			optimalZoneY.Width = 40;
			optimalZoneY.End = ymax+this.optimalZoneY.Width;
			optimalZoneY.Period = 200;
			optimalZoneY.Text = "Maximum Torque :"+ymax;
			optimalZoneY.TextColor = Color.Red;
			optimalZoneY.TextAlignment=ContentAlignment.MiddleCenter;
			optimalZoneY.Font =  new Font("Tahoma",12);
			optimalZoneY.Interior = new BrushInfo(230, new BrushInfo(GradientStyle.Vertical  ,Color.FromArgb(41,65,125) , Color.FromArgb(41,65,125)));
			this.chartControl1.PrimaryYAxis.StripLines.Add(this.optimalZoneY);
		}

		
		private void radioButton1_CheckedChanged(object sender, System.EventArgs e)
		{
			if(this.radioButton1.Checked)
			{
				this.optimalZoneX.Enabled = true;
				this.optimalZoneY.Enabled = false;
			}
			else
			{
				this.optimalZoneX.Enabled = false;
				this.optimalZoneY.Enabled = true;
			}
			this.chartControl1.Redraw(true);
		}

        
	}
}
